{-# OPTIONS_GHC -package plugins #-}

import Network.FastCGI
import System.Plugins

import System.Posix.Env (setEnv)

loadMod :: FilePath -> IO (CGI CGIResult)
loadMod file =
    do status <- make file []
       obj    <- case status of
		   MakeSuccess _ o -> return o
		   MakeFailure e   -> mapM_ putStrLn e >> fail "failed"
       m_v    <- load obj ["."] [] "cgiMain"
       val    <- case m_v of
		   LoadSuccess _ v -> return v
		   _               -> fail "load failed"
       return val

dynMain :: CGI CGIResult
dynMain = liftIO $ loadMod "hs/DynTest.hs"

main = do
       setEnv "HOME" "" False -- workaround
       setEnv "LD_LIBRARY_PATH" "/lib:/usr/lib:/usr/local/lib" False
       runFastCGI cgiMain